#!/usr/bin/env python
# -*- coding: UTF8 -*-

# This file is part of PySms.
#
# PySms - A text messenger for various swiss providers
# Copyright (C) 2007 Andreas Maechler <amaechler@gmx.ch>
#
# PySms is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
# 
# PySms is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import re
import urllib

# Global variables
maxmsgsize = 458

def login( self ):

    try:
        loginURL = 'https://www.swisscom-mobile.ch/youth/sms_senden-de.aspx?login'
        loginValues = { 'isiwebuserid' : self.swisscom[0].decode( 'utf-8' ).encode( 'iso-8859-1' ),
                        'isiwebpasswd' : self.swisscom[1].decode('rot13').encode( 'iso-8859-1' ),
                        
                        'isiwebjavascript' : 'No',
                        'isiwebappid' : 'mobile',
                        'isiwebmethod' : 'authenticate',
                        'isiweburi' : '/youth/sms_senden-de.aspx',
                        'isiwebargs' : 'login'
                      }
        
        loginData = urllib.urlencode( loginValues )
        #print loginData

        # Create a request object
        req = self.Request( loginURL, loginData, self.htmlHeaders )

        # Open it to return a handle on the url
        handle = self.urlopen( req )

    except IOError, e:
        if hasattr( e, 'code' ):
            self.error_dialog( 'Failed to log on to the swisscom server.\n'
                            + 'Error code - %d' % e.code )
        elif hasattr( e, 'reason' ):
            self.error_dialog( 'Failed to log on to the swisscom server.\n'
                            + '%d' % e.reason[0] + ': ' + e.reason[1] + '.' )
        
        # print handle.read()
        
        return False

    return True

def logout( self ):
    self.cj.clear()
    self.sentcounter = 0

def send( self ):

    sendURL = 'https://www.swisscom-mobile.ch/youth/sms_senden-de.aspx'

    # Get message and convert into the correct charset
    message = self.msgbuffer.get_text( self.msgbuffer.get_start_iter(), self.msgbuffer.get_end_iter() )
    message = message.decode( 'utf-8' ).encode( 'iso-8859-1' )
    
    try:
        while message: # this means while message != ''

            # If the message is larger then the max. size message we can send
            if len( message ) > maxmsgsize:
                # Search for a space to split the message nicely
                for i in range( maxmsgsize ):
                    if message[maxmsgsize - i] == ' ':
                        break

                # If there was no whitespace to split the message, just send the max. message
                if ( i == maxmsgsize-1 ):
                    send_msg = message[:maxmsgsize-1]
                    message = message[maxmsgsize:]
                # Else split the message at the found whitespace
                else:
                    send_msg = message[:maxmsgsize - i]
                    message = message[maxmsgsize - i + 1:]

            else:
                send_msg = message
                message = ''

            # Prepare the send values (defined by the swisscom online form)
            sendValues = {  'CobYouthSMSSenden:txtNewReceiver' : self.receivernumber.get_text(),
                            'CobYouthSMSSenden:txtMessage'     : send_msg,

                            '__VIEWSTATE'                      : '',
                            
                            '__VIEWSTATE_SCM'                  : '1',

                            '__EVENTTARGET'                    : '',
                            '__EVENTARGUMENT'                  : '',
                            
                            'txtMessageDisabled'               : ' - sent by xtrazone.ch',
 
                            'CobYouthSMSSenden:btnSend'        : 'Senden',
                            'FooterControl:hidNavigationName'  : 'SMS senden',
                            'FooterControl:hidMailToFriendUrl' : 'youth/sms_senden-de.aspx'
                           }

            sendData = urllib.urlencode( sendValues )

            req = self.Request( sendURL, sendData, self.htmlHeaders )
            handle = self.urlopen( req )
            
            # print handle.read()
			
            try:
            	smsleft = int( re.search( '<span id=\"CobYouthMMSSMSKonto_lblGuthaben\">(.*?)</span>', handle.read()).group( 1 ) )
            except:
            	smsleft = None;  


        # If the user would like an affirmation for the sent message
        if self.affirmation.get_active():

            # Check if the user has entered a sender number
            if ( self.sender == None ):
                self.error_dialog( 'Failed to send confirmation.\nPlease enter your mobile number in the preferences.\n' )
            else:
                sendValues['CobYouthSMSSenden:txtNewReceiver'] = self.sender
                sendValues['CobYouthSMSSenden:txtMessage'] = 'Your message to ' + self.receivername + ' (' + self.receivernumber.get_text() + ') has been sent successfully through Swisscom.'

                sendData = urllib.urlencode( sendValues )

                req = self.Request( sendURL, sendData, self.htmlHeaders )
                handle = self.urlopen( req )
                
                try:
            		smsleft = int( re.search( '<span id=\"CobYouthMMSSMSKonto_lblGuthaben\">(.*?)</span>', handle.read()).group( 1 ) )
            	except:
					smsleft = None;

    except IOError, e:
        if hasattr( e, 'code' ):
            self.error_dialog( 'Failed to send message from the swisscom server.\n'
                                                + 'Error code - %d' % e.code )
        elif hasattr( e, 'reason' ):
            self.error_dialog( 'Failed to send message from the swisscom server.\n'
                                                + '%d' % e.reason[0] + ': ' + e.reason[1] + '.' )
        
        # print handle.read()
